% GMM code

function varargout = gmm(X, K_or_centroids)

    % input X:N-by-D data matrix
    % input K_or_centroids: K-by-D centroids
    
    % ֵ
    threshold = 1e-15;
    % ȡά
    [N, D] = size(X);
    % жǷΪ
    if isscalar(K_or_centroids)
        % ǱѡȡK
        K = K_or_centroids;
        rnpm = randperm(N); % ҵN
        centroids = X(rnpm(1:K), :);
    else   % 󣬸ÿһĳʼ
        K = size(K_or_centroids, 1);
        centroids = K_or_centroids;
    end
    
    % ģͳֵ
    [pMiu, pPi, pSigma] = init_params();
    
    Lprev = -inf;
    while true
        % E-step,ֵ
        % Px: N-by-K 
        Px = calc_prob();
        
        % pGammaµֵ,ռȨ
        % pPi:1-by-K     pGamma:N-by-K
        pGamma = Px ./ repmat(pPi, N, 1);
        % pGammaÿһн,sum(x,2):ÿһ
        pGamma = pGamma ./ repmat(sum(pGamma, 2) ,1 , K);
        
        % M-step
        % ÿһµֵ
        Nk = sum(pGamma,1);
        pMiu = diag(1./Nk)*pGamma'*X;
        pPi = Nk/N;
        for kk = 1:K
           Xshift = X - repmat(pMiu(kk, :) ,N, 1);
           pSigma(:,:,kk) = (Xshift'*(diag(pGamma(:,kk))*Xshift)) / Nk(kk);
        end
        
        % ۲convergence
        L = sum(log(Px*pPi'));
        if L-Lprev < threshold
            break;
        end
        Lprev = L;
        
    end
    
    % ж
    if nargout == 1
        varargout = {Px};
    else
        model = [];
        model.Miu = pMiu;
        model.Sigma = pSigma;
        model.Pi = pPi;
        varargout = {Px, model};
    end
    
    function [pMiu, pPi, pSigma] = init_params()
       pMiu = centroids; % ֵK
       pPi = zeros(1, K); % 
       pSigma = zeros(D, D, K); % ЭÿһD-by-D
       
       % (X - pMiu)^2 = X^2 + pMiu^2 - 2*X*pMiu
       distmat = repmat(sum(X.*X, 2), 1, K) + repmat(sum(pMiu.*pMiu, 2)', N, 1) - 2*X*pMiu';
       [~, labels] = min(distmat, [], 2); % ҳÿһеСֵ,еλ
       
       for k=1:K   %ʼ
           Xk = X(labels == k, :);
           pPi(k) = size(Xk, 1)/N;
           pSigma(:, :, k) = cov(Xk);
       end             
    end

    % ֵ
    function Px = calc_prob()
        Px = zeros(N,K);
        for k=1:K
            Xshift = X - repmat(pMiu(k,:),N,1);
            inv_pSigma = inv(pSigma(:,:,k)+diag(repmat(threshold, 1, size(pSigma(:,:,k),1))));
            tmp = sum((Xshift*inv_pSigma).*Xshift, 2);
            coef = (2*pi)^(-D/2)*sqrt(det(inv_pSigma));
            Px(:,k) = coef * exp(-1/2*tmp);
        end
    end
      

end